#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define DATOTEKABIN "proizvodi.dat"
#define DATOTEKAIZVESTAJ "izvestaj.txt"


typedef struct proizvod {
	char naziv[50];
	double cena;
}PROIZVOD;

typedef PROIZVOD NIZ[50];

typedef struct cvor *PCVOR;

typedef struct cvor {
	PROIZVOD podatak;
	PCVOR sledeci;
}CVOR;

void unosUNiz(NIZ niz,int *n);
void prikazNiza(NIZ niz,int n);
void cuvanjeNizaUBinDatoteci(NIZ niz,int  n, char naziv[]);
void prikazSadrzajaBinDatoteke(char naziv[]);
void prebacivanjeSkupihProizvodaUListu(char naziv[], PCVOR *glava, double cena);
void prikazListe(PCVOR glava);
void formiranjeIzvjestaja(PCVOR glava, char naziv[]);


int main() {
	NIZ niz;
	PCVOR glava = NULL;
	int n = 0;
	int izbor;
	double cena=30;

	do{

	printf("1-unos proizvoda u niz\n\
	2-prikazNiza\n\
	3-cuvanje niza u binarnoj datoteci\n\
	4-prikaz sadrzaja binarne datoteke\n\
	5-prebacivanje skupih proizvoda u listu\n\
	6-prikaz liste\n\
	7-formiranje izvestaja\n\
	8-kraj!\n");
	printf("Odaberite opciju:\n");
	scanf("%d", &izbor);
	getchar();
	switch (izbor)
	{
	case 1: 
		unosUNiz(niz, &n);
		break;
	case 2:
		prikazNiza(niz, n);
		break;
	case 3:
		cuvanjeNizaUBinDatoteci(niz, n, DATOTEKABIN);
		break;
	case 4:
		prikazSadrzajaBinDatoteke(DATOTEKABIN);
		break;
	case 5: 
		prebacivanjeSkupihProizvodaUListu(DATOTEKABIN, &glava, cena);
		break;
	case 6:
		prikazListe(glava);
		break;
	case 7:
		formiranjeIzvjestaja(glava, DATOTEKAIZVESTAJ);
		break;
	case 8:
		return 0;
	default:
		printf("Odabrana opcija ne postoji!\n");
		break;
	}
	} while (1);


	system("pause");
	return 0;
}

PROIZVOD unosProizvoda() {
	PROIZVOD p;
	printf("Unesite naziv proizvoda\n");
	gets(p.naziv);
	printf("Unesite cenu proizvoda\n");
	scanf("%lf", &p.cena);
	getchar();
	return p;
}

void unosUNiz(NIZ niz, int *n) {
	char izbor='d';
	
	do {
		niz[(*n)++] = unosProizvoda();
		printf("Da li zelite da unesete proizvod\n\
		d-da\n\
		n-ne\n");
		izbor=getc(stdin);
		getchar();

	} while (izbor!='n');
}

void prikaziProizvod(PROIZVOD proizvod) {
	printf("Proizvod %s, ima cenu %lf\n", proizvod.naziv, proizvod.cena);
}

void prikazNiza(NIZ niz, int n) {
	int i;
	printf("Sadrzaj niza je\n");
	for ( i = 0; i < n; i++)
	{
		prikaziProizvod(niz[i]);
	}
}

void cuvanjeNizaUBinDatoteci(NIZ niz, int  n, char naziv[]) {
	FILE* binDat = fopen(naziv, "wb");

	if (binDat == NULL) {
		printf("Greska prilikom otvaranja datoteke\n");
		return;
	}

	fwrite(niz, sizeof(PROIZVOD), n, binDat);

	fclose(binDat);
}

void prikazSadrzajaBinDatoteke(char naziv[]) {
	FILE* binDat = fopen(naziv, "rb");
	PROIZVOD proizvod;

	if (binDat == NULL) {
		printf("Greska prilikom otvaranja datoteke\n");
		return;
	}

	while (fread(&proizvod, sizeof(PROIZVOD), 1, binDat)!=0) {
		prikaziProizvod(proizvod);
	}

	fclose(binDat);
}

void dodajProizvodUListu(PCVOR *glava, PROIZVOD p) {
	
	PCVOR novi=malloc(sizeof(CVOR));
	novi->podatak = p;
	novi->sledeci = *glava;

	*glava = novi;
	
}
void prebacivanjeSkupihProizvodaUListu(char naziv[], PCVOR *glava, double cena){
	FILE* binDat = fopen(naziv, "rb");
	PROIZVOD proizvod;

	if (binDat == NULL) {
		printf("Greska prilikom otvaranja datoteke\n");
		return;
	}

	while (fread(&proizvod, sizeof(PROIZVOD), 1, binDat) != 0) {
		if (proizvod.cena > cena) {
			dodajProizvodUListu(glava, proizvod);
		}
	}

	fclose(binDat);
}

void prikazListe(PCVOR glava){

	PCVOR tekuci = glava;
	while (tekuci != NULL) {
		prikaziProizvod(tekuci->podatak);
		tekuci = tekuci->sledeci;
	}

}
void formiranjeIzvjestaja(PCVOR glava, char naziv[]){
	FILE* tekDat = fopen(naziv, "w");
	double suma = 0;
	int brojElemenata = 0;

	if (tekDat == NULL) {
		printf("Greska prilikom otvaranja datoteke\n");
		return;
	}

	fprintf(tekDat, "%-30s, %-13s\n", "Naziv", "Cena");

	PCVOR tekuci = glava;
	while (tekuci != NULL) {
		fprintf(tekDat, "%-30s, %-10.2lf\n", tekuci->podatak.naziv, tekuci->podatak.cena);
		suma = suma + tekuci->podatak.cena;
		brojElemenata++;
		tekuci = tekuci->sledeci;
	}

	fprintf(tekDat, "Prosjecna cijena skupih proizvoda je %.2lf\n", suma / brojElemenata);

	fclose(tekDat);
}